package com.openhis.web.pharmacyWarehousemanage.appservice.impl;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.stream.Collectors;

import javax.annotation.Resource;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.core.common.core.domain.R;
import com.core.common.utils.AssignSeqUtil;
import com.core.common.utils.DateUtils;
import com.core.common.utils.MessageUtils;
import com.openhis.common.constant.CommonConstants;
import com.openhis.common.constant.PromptMsgConstant;
import com.openhis.common.enums.*;
import com.openhis.common.utils.EnumUtils;
import com.openhis.web.inventorymanage.dto.ProductStocktakingInitDto;
import com.openhis.web.pharmacyWarehousemanage.appservice.IPharmacyWarehouseCommonService;
import com.openhis.web.pharmacyWarehousemanage.appservice.IPharmacyWarehouseStockOutOrderService;
import com.openhis.web.pharmacyWarehousemanage.dto.PharmacyWarehouseDetailDto;
import com.openhis.web.pharmacyWarehousemanage.dto.PharmacyWarehouseInitDto;
import com.openhis.web.pharmacyWarehousemanage.mapper.PharmacyWarehouseCommonMapper;
import com.openhis.web.pharmacyWarehousemanage.mapper.PharmacyWarehouseStockOutOrderMapper;
import com.openhis.workflow.domain.SupplyRequest;
import com.openhis.workflow.service.ISupplyRequestService;

/**
 * 药库出库单
 *
 * @author yuxj
 * @date 2025-07-22
 */
@Service
public class PharmacyWarehouseStockOutOrderServiceImpl implements IPharmacyWarehouseStockOutOrderService {

    @Resource
    private AssignSeqUtil assignSeqUtil;
    @Resource
    private ISupplyRequestService supplyRequestService;

    @Autowired
    private IPharmacyWarehouseCommonService pharmacyWarehouseCommonService;
    @Autowired
    private PharmacyWarehouseCommonMapper pharmacyWarehouseCommonMapper;
    /**
     * 初始化
     *
     * @return 初始化信息
     */
    @Override
    public R<?> init() {

        PharmacyWarehouseInitDto purchaseOrderInitDto = pharmacyWarehouseCommonService.init();

        // 单据分类
        List<PharmacyWarehouseInitDto.IntegerOption> supplyCategoryOption = new ArrayList<>();
//        supplyCategoryOption.add(new PharmacyWarehouseInitDto.IntegerOption(SupplyCategory.IN_HOSPITAL_OUTBOUND.getValue(),
//            SupplyCategory.IN_HOSPITAL_OUTBOUND.getInfo()));
//        supplyCategoryOption.add(new PharmacyWarehouseInitDto.IntegerOption(SupplyCategory.OUT_OF_HOSPITAL_OUTBOUND.getValue(),
//            SupplyCategory.OUT_OF_HOSPITAL_OUTBOUND.getInfo()));
//        supplyCategoryOption.add(new PharmacyWarehouseInitDto.IntegerOption(SupplyCategory.OTHER_OUTBOUND.getValue(),
//            SupplyCategory.OTHER_OUTBOUND.getInfo()));

        purchaseOrderInitDto.setSupplyCategoryOptions(supplyCategoryOption);

        return R.ok(purchaseOrderInitDto);
    }

    /**
     * 出库单单据详情
     *
     * @param busNo 单据号
     * @param pageNo 当前页码
     * @param pageSize 查询条数
     * @return 出库单单据详情
     */
    @Override
    public R<?> getDetailPage(String busNo, Integer pageNo, Integer pageSize) {

        Page<PharmacyWarehouseDetailDto> stockOutOrderDtoDetailPage =
            pharmacyWarehouseCommonMapper.getDetailPage(new Page<>(pageNo, pageSize), busNo);

        stockOutOrderDtoDetailPage.getRecords().forEach(e -> {
            // 单据分类
            e.setCategoryEnum_enumText(EnumUtils.getInfoByValue(SupplyCategory.class, e.getCategoryEnum()));
            // 单据状态
            e.setStatusEnum_enumText(EnumUtils.getInfoByValue(SupplyStatus.class, e.getStatusEnum()));
            // 单据类型
            e.setTypeEnum_enumText(EnumUtils.getInfoByValue(SupplyType.class, e.getTypeEnum()));

        });
        List<PharmacyWarehouseDetailDto.Option> unitList;
        for (PharmacyWarehouseDetailDto item : stockOutOrderDtoDetailPage.getRecords()) {
            unitList = new ArrayList<>();
            unitList.add(new PharmacyWarehouseDetailDto.Option(item.getMaxUnitCode(),item.getMaxUnitCode_dictText()));
            unitList.add(new PharmacyWarehouseDetailDto.Option(item.getMinUnitCode(),item.getMinUnitCode_dictText()
            ));

            item.setUnitList(unitList);
        }

        return R.ok(stockOutOrderDtoDetailPage);
    }


    /**
     * 获取单据号
     *
     * @return 初始化信息
     */
    @Override
    public R<?> getBusNo() {

        ProductStocktakingInitDto initDto = new ProductStocktakingInitDto();
        // 单据号
        initDto.setBusNo(assignSeqUtil.getSeqByDay(AssignSeqEnum.REQUISITION_NUM.getPrefix(), 4));

        return R.ok(initDto);
    }

    /**
     * 添加/编辑出库单
     *
     * @param stockOutOrderDtoList 出库信息
     * @return 操作结果
     */

    @Override
    public R<?> addOrEditStockOutOrder(List<PharmacyWarehouseDetailDto> stockOutOrderDtoList) {
        // 请求数据取得
        List<SupplyRequest> requestList = supplyRequestService.getSupplyByBusNo(stockOutOrderDtoList.get(0).getBusNo());
        if (!requestList.isEmpty()) {
            // 请求id取得
            List<Long> requestIdList = requestList.stream().map(SupplyRequest::getId).collect(Collectors.toList());
            // 单据信息删除
            supplyRequestService.removeByIds(requestIdList);
        }
        //添加原始单据号
        if(stockOutOrderDtoList.get(0).getOriginalBusNo()!=null){
            // 审批单据并返回单据详情
            List<SupplyRequest> agreedList = supplyRequestService.addOriginalBusNo(stockOutOrderDtoList.get(0).getOriginalBusNo(), stockOutOrderDtoList.get(0).getBusNo());
            if (agreedList.isEmpty()) {
                return R.fail(MessageUtils.createMessage(PromptMsgConstant.Common.M00007, null));
            }
        }

        List<SupplyRequest> supplyRequestList = new ArrayList<>();
        Date applyTime = DateUtils.getNowDate();
        for (PharmacyWarehouseDetailDto item : stockOutOrderDtoList) {
            SupplyRequest supplyRequest = new SupplyRequest().setBusNo(item.getBusNo())
                .setTypeEnum(SupplyType.CABINET_STOCKOUT.getValue())
                .setStatusEnum(SupplyStatus.PENDING_REVIEW.getValue()).setCategoryEnum(item.getCategoryEnum())
                .setItemTable(CommonConstants.TableName.MED_MEDICATION_DEFINITION).setItemId(item.getItemId())
                .setUnitCode(item.getUnitCode()).setItemQuantity(item.getItemQuantity()).setPrice(item.getPrice())
                .setTotalPrice(item.getTotalPrice()).setRetailPrice(item.getRetailPrice())
                .setTotalRetailPrice(item.getTotalRetailPrice()).setBatchInventory(item.getBatchInventory())
                .setSpecificationInventory(item.getSpecificationInventory()).setStartTime(item.getStartTime())
                .setEndTime(item.getEndTime()).setPractitionerId(item.getPractitionerId())
                .setLotNumber(item.getLotNumber()).setTraceNo(item.getTraceNo())
                .setTraceNoUnitCode(item.getTraceNoUnitCode()).setSupplierId(item.getSupplierId())
                .setReason(item.getReason()).setSourceTypeEnum(LocationForm.CABINET.getValue())
                .setSourceLocationId(item.getSourceLocationId()).setPurposeTypeEnum(LocationForm.PHARMACY.getValue())
                .setPurposeLocationId(item.getPurposeLocationId())
                .setApplicantId(item.getApplicantId()).setApplyTime(applyTime).setRemake(item.getRemake());
            supplyRequestList.add(supplyRequest);
        }
        // 更新请求表
        boolean flg = supplyRequestService.saveOrUpdateBatch(supplyRequestList);
        if (!flg) {
            return R.fail(MessageUtils.createMessage(PromptMsgConstant.Common.M00011, null));
        }

        return R.ok(MessageUtils.createMessage(PromptMsgConstant.Common.M00004, null));
    }

}
